#!ruby         
# === export_webgl_150420.rb ===
# 2011/Mar - 2014/Nov webgl_export.rb
#          - 2015/Apr change library canvas.js >> three.js
#                                              by Akitenh
# 
# SketchUp's Plug_in script: Export SketchUpModel to WebGL-script
# based on WebGL codes -- three.js(r7.10)
#2015/12/11 - Modified by TAK2HATA.
#Exporter for webGL.(Based on SU2WEBGL by AKITENKOSI).
#General disclaimer
#I MAKES NO GUARANTEE OF VALIDITY about this script.
#Please use this script at your own risk.
#免責事項
#このスクリプトによって如何なる損害が発生しても製作者は責任を負いません。各人の責任においてご使用ください
#このスクリプトは秋天越様作のSU2WEBGLをもとに改変し作られています。

require 'sketchup.rb'
#require 'kconv'
module TAK2HATA
module WEBGL_EXPORT
class Webgl_export
	def show_status(m,prpt,fin=false)
	if @chklog == "YES"
		@log.push "#{Time.now.to_i}:" + m
		if fin == true or ( Time.now.to_f - @wait ) > 1.0
			open(@logfile,'w'){|f|
				f.puts @log.reverse.join("<br>")
			}
			@wait = Time.now.to_f
		end
	else
		if( Time.now.to_f - @wait ) > 0.5
			Sketchup.set_status_text m
			p m
			@wait = Time.now.to_f
		end
	end
	end
  def init_props()
    @vi=@fi=@ei=0
    @vts=[]
	@fcs = []
	@uvs = []
	@eds = []
	@vtscnt = 0
	@fcscnt = 0
	@uvscnt = 0
	@edscnt = 0
	@vts[@vtscnt] = []
	@fcs[@fcscnt] = []
	@uvs[@uvscnt] = []
	@eds[@edscnt] = []
	@mti=[]   #material_index
  end
  def initialize( export_onefile = false , use_texture = false )
	@use_texture = use_texture
	#//インスタンスするのもいいけど、どのみちメッシュ量には限界があると思うので、geomを定義して、変形してからmeshを作りシーンに登録する。
	#//componentオブジェクトごとに分割しgeomにしてから、インスタンスごとにマテリアルインデックスに対応したマテリアルリストをつくる。
	#//compid = [nv,vlist[],nf,fcslist[],ned,edlist[],matilist[]]
	#//[compid,defmatslist[],mtxlist[]]
	#//matlist[]とtexlist[]は共通
	#//のような形で展開するdefmatlistには置き換え分のマテリアルのみを入れてmateriallist[0]を差し替えて使う
	#//sketchup側ではインスタンスをまず書き出して登録し、modelを解析するときに登録済みのインスタンスはmatlistとmtxlistに保存して管理する。
	@wait = Time.now.to_f

	@logfile = File.join(File.dirname(__FILE__),"webgl_export_log.html")
	@log = []
	@prec=5 #小数点以下有効桁数、単位cm

    
    @mtl=[["default", 0, "0xcccccc", 1.0, ""]] #used_material_color
	@mthash = Hash.new
	@mthash[nil] = 0
    @txs=[]
	mydir = File.dirname(__FILE__)
	threejsfile = File.join(mydir,"three.min.js")
	orbitfile = File.join(mydir,"OrbitControlsTH.min.js")
	axisfile = File.join(mydir,"LineAxisHelper.js")
	guifile = File.join(mydir,"DAT.GUI.min.js")

    model = Sketchup.active_model
	scenelength = model.bounds.diagonal
	scenecenter = model.bounds.center
    ents1 = ente  = model.entities
    ##ent1  = model.selection
    return if ents1.count == 0

    gscl = 1000.0

    svname, @enbltx = prompt()
    return if svname == ""
	starttime = Time.now.to_f
	export_textures(svname)
	@chklog = "NO"
	if @chklog == "YES"
		show_status "#{Time.now.strftime("%H%M%S")}:Start Export WebGL<br>\n",true,true
		UI.openURL File.join(File.dirname(__FILE__),"log_viewer.html")
	end

    view = model.active_view
    cam = view.camera
    ceye = cam.eye
	cvec = ceye.vector_to(cam.target)
	if scenelength != 0.0 and cvec.length != 0.0
	end
    ctgt = ceye + cvec
    defmat="default"
	po=Geom::Point3d.new
	mns = 1.inch.to_cm
	
    #t0 = Geom::Transformation.translation(po.vector_to(Geom::Point3d.new( 0,0,0 ))) * Geom::Transformation.scaling(mns)
	t0 = Geom::Transformation.scaling(mns)
	scenemin = model.bounds.corner(2).transform(t0)
	scenemax = model.bounds.corner(5).transform(t0)

	pcam=ceye.transform(t0)
	ptgt=ctgt.transform(t0)
	
	
	htmlheader = get_html_header()
	geomfilename = File.basename(svname,".html") + "geom.js"
	savedir = File.dirname(svname)
	geomfile = File.join(savedir,geomfilename)
	if export_onefile
		geomfile = svname
		f=open(geomfile, "w")
		f.print (htmlheader)
		f.print %Q(<script itype="text/javascript" >)
		f.print (open(threejsfile, &:read))
		f.print "</script>"
		f.print %Q(<script itype="text/javascript" >)
		f.print (open(orbitfile, &:read))
		f.print "</script>"
		f.print %Q(<script itype="text/javascript" >)
		f.print (open(axisfile, &:read))
		f.print "</script>"
		f.print %Q(<script itype="text/javascript" >)
		f.print (open(guifile, &:read))
		f.print "</script>"
		f.print %Q(<script itype="text/javascript" >)
		f.print ("function main_wgl() { prec=#{@prec};geomlist=[\n")
		f.close
	else
		htmlheader += %Q(
		  <script src="three.min.js"></script>       <!-- 3Dライブラリ -->
		  <script src="OrbitControlsTH.min.js"></script>       <!-- 統合オービットコントローラ -->
		  <script src="LineAxisHelper.js"></script>      <!-- 軸線表示ライブラリ -->
		  <script src='DAT.GUI.min.js'></script>
		  <script src="#{geomfilename}"></script>      <!-- 形状データ -->
		)
		filecopy(threejsfile, File.join(savedir,"three.min.js"))
		filecopy(orbitfile , File.join(savedir,"OrbitControlsTH.min.js"))
		filecopy(axisfile , File.join(savedir,"LineAxisHelper.js"))
		filecopy(guifile , File.join(savedir,"DAT.GUI.min.js"))
		f=open(geomfile, "w")
		f.print ("function main_wgl() { prec=#{@prec};geomlist=[\n")
		f.close
	end
	
	#最初にent1から掘り下げる
	
	init_props()
	@geomlist = Hash.new#[compid,defmatslist[],mtxlist[]]
	@geomlist[ Sketchup.active_model ] = []
	@geomlist[ Sketchup.active_model ].push [ nil , Geom::Transformation.new ]
	#インスタンスの情報を収集
	show_status "search instances", SB_PROMPT
	search_instances(ents1,Geom::Transformation.new,nil)
	show_status "search instances end", SB_PROMPT
	
	#show_status "search face", SB_PROMPT
    #search_face(ents1, t0, nil)
	#show_status "search face end", SB_PROMPT
	f=open(geomfile, "a")
	#writing_geoms(f)
	#f.print (",\n")
	#f.close

	@geomlist.each{|key,val|
		show_status "search faces of instance", SB_PROMPT
		init_props()
		search_face(key.entities , t0 , nil)
		show_status "search faces of instance end", SB_PROMPT
		#if @vi > 0
			#f=open(geomfile, "a")
			writing_geoms(f)
			f.print (",\n")
			#f.close
		#end
	}
	#f=open(geomfile, "a")
	f.print ("]\n")
	f.print ("ngeom=#{@geomlist.size};\n")
	f.print ("inslist=[")
	geomi = 0
	xrot = Geom::Transformation.rotation([0,0,0],Geom::Vector3d.new(1,0,0),90.degrees)
	@geomlist.each{|key,val|
		f.print ("{nins:#{val.size},props:[")
		val.each{|ins_mat,ins_tr|
			f.print ("{dfmat:#{@mthash[ins_mat]},")
			ins_tr2 = t0 * ins_tr * t0.inverse
			f.print ("matrix:#{(ins_tr2).to_a}},")
		}
		f.print ("]},")
		geomi += 1
	}
	f.print ("]\n")
    mlst=""; i=0
    @mtl.each do |m|
	  if @use_texture
		mlst += "mat[#{m[1]}]=[ #{m[2]}, #{m[3]}, \'#{m[4]}\' ];\n"
	  else
		mlst += "mat[#{m[1]}]=[ #{m[2]}, #{m[3]}, \'\' ];\n"
	  end
      i+=1
    end
	show_status "arraying material end", SB_PROMPT
	
    tlst=""; i=0
    @txs.each do |m|
      tlst << "tex[#{m[1]}]=\'gl_image\/#{m[2]}\';\n"
      i+=1
    end
	show_status "arraying texture end", SB_PROMPT
	f.print ("mat =[];#{mlst}")
	if @use_texture
		f.print ("tex =[];#{tlst}")
	end
	f.print ("init();render();}")
	if export_onefile
		f.print "</script>"
	end
	f.close

	show_status "wrighting geom file end", SB_PROMPT
	prec="%.3f"
	scene_code = ""
	scenelist = []
	model.pages.each{|pg|
		pgceye = pg.camera.eye
		cvec = pgceye.vector_to(pg.camera.target)
		if scenelength != 0.0 and cvec.length != 0.0
			#cvec.length = scenelength * 0.5
		end
		pgctgt = pgceye + cvec
		pgcam=pgceye.transform(t0)
		pgtgt=pgctgt.transform(t0)
		scene_code += "case \"#{pg.name}\":"

		scene_code += "cpos=[#{sprintf( "#{prec},#{prec},#{prec}",pgcam.x*1.0,pgcam.z*1.0,-pgcam.y*1.0)}];"
		scene_code += "ctgt=[#{sprintf( "#{prec},#{prec},#{prec}",pgtgt.x*1.0,pgtgt.z*1.0,-pgtgt.y*1.0)}];break;\n"
		scenelist.push "\"#{pg.name}\""
	}
	htmltemp = get_html_templete()
	htmltemp.sub!(/GEOMJS_FILENAME/,geomfilename)
	htmltemp.sub!(/CAMEYE/,"#{sprintf( "#{prec},#{prec},#{prec}",pcam.x*1.0,pcam.z*1.0,-pcam.y*1.0)}")
	htmltemp.sub!(/CAMTGT/,"#{sprintf( "#{prec},#{prec},#{prec}",ptgt.x*1.0,ptgt.z*1.0,-ptgt.y*1.0)}")
	htmltemp.sub!(/SCENE_LIST/,scenelist.join(","))
	htmltemp.sub!(/SCENE_SELECT/,scene_code)
	htmltemp.sub!(/SCENE_MAX_LENGTH/,"#{(scenelength * mns * 10).to_i}")
	htmltemp.sub!(/SCENESIZE/,"#{sprintf( "#{prec},#{prec},#{prec}",scenemax.x*1.0-scenemin.x*1.0,scenemax.z*1.0-scenemin.z*1.0,-scenemax.y*1.0+scenemin.y*1.0)}")
	htmltemp.sub!(/SCENEMIN/,"#{sprintf( "#{prec},#{prec},#{prec}",scenemin.x*1.0,scenemin.z*1.0,-scenemin.y*1.0)}")
	#orbit controlを使うとlookatは無効
	show_status "reading template end", SB_PROMPT
    
	if export_onefile
		f=open(svname, "a")
		f.print (htmltemp)
		f.close
	else
		f=open(svname, "w+")
		f.print (htmlheader)
		f.print (htmltemp)
		f.close
	end
    show_status "wrighting htmlend", SB_PROMPT

	show_status "finished!:time#{Time.now.to_f - starttime}sec", SB_PROMPT
	res = UI.messagebox( "finished!: elapsed time is #{sprintf("%.5f",Time.now.to_f - starttime)}sec.\nopen with your default browser?" ,MB_YESNO)
	if res == 6#YES
		UI.openURL(svname)
	end
  end
  def filecopy(ofile,tfile)
	if ofile and tfile and ofile != "" and tfile != "" and File.exist?(ofile) and ofile != tfile
		f=open(tfile, "w")
		f.print (open(ofile, &:read))
		f.close
	end
  end
  def writing_geoms(f)
	delim = ","
      f.print ("{nv:#{@vi},\n")
	  f.print ("v:[")
	  i = 0
	  @vts.each{|vtl|
		f.print (vtl.join(delim))
		if i < @vtscnt
			f.print (delim)
		end
		i += 1
	  }
	  f.print "],\n"
	  show_status "wrighting vertices end", SB_PROMPT
#      f.print (cns[1] + "\n")
#      f.print (@vts.inspect)
      f.print ("nf:#{@fi},\n")
	  f.print ("f:[")
	  i = 0
	  @fcs.each{|fcs|
		f.print (fcs.join(delim))
		if i < @fcscnt
			f.print (delim)
		end
		i += 1
	  }
	  f.print "],\n"
	  show_status "wrighting faces end", SB_PROMPT

	#まだテクスチャは対応できていないので保留
	if @use_texture
	  f.print ("uv:[")
	  i = 0
	  @uvs.each{|uvs|
		f.print (uvs.join(delim))
		if i < @uvscnt
			f.print (delim)
		end
		i += 1
	  }
	  f.print "],\n"
	end

	  show_status "wrighting uvs end", SB_PROMPT
	  f.print ("ne:#{@ei},\n")
	  f.print ("ed:[")
	  i = 0
	  @eds.each{|eds|
		f.print (eds.join(delim))
		if i < @edscnt
			f.print (delim)
		end
		i += 1
	  }
	  f.print "],\n"
	  show_status "wrighting eds end", SB_PROMPT
	  f.print ("mti:[#{ @mti.join(",")}]")
	  f.print ("\n}//geom end\n")
	show_status "wrighting mat index end", SB_PROMPT
#      f.print (cns[5] + "\n")
#      f.print (@mti.inspect)

  end
#----------------------------
  def search_face(et1, t0, mt0)
  #グループだけ掘り下げてfaceを取得してゆく
  fcs = et1.find_all{|e| e.is_a?(Sketchup::Face)}
  inss = et1.find_all{|e| e.is_a?(Sketchup::ComponentInstance)}
  grps = et1.find_all{|e| e.is_a?(Sketchup::Group)}
  #entities内でエッジ登録を蓄積して必要分に限定する
  @edslist = Hash.new
  @vtsindices = Hash.new
	fcs.each{|e| 
		if e.visible? and e.layer.visible?
			check_face(e,t0,mt0)
		end
	}
	@vi += @vtsindices.size
	@edslist.clear
	@vtsindices.clear
	grps.each{|e|
		if e.visible? and e.layer.visible?
			mt1 = e.material || mt0
			t1  = t0 * e.transformation
			sel = e.definition.entities
			search_face(sel, t1, mt1)
		end
	}
  end
  def search_instances(et1,t0,mt0)
  #インスタンスの位置・材質情報のみ蓄積
	if not @mthash[mt0]
		matname = "default"
		matname = mt0.name if mt0 != nil
		has_texture = ""
		has_texture = mt0.texture if(mt0 != nil and mt0.materialType == 1)
		self.store_mat(mt0, matname, has_texture)
	end
	inss = et1.find_all{|e| e.is_a?(Sketchup::ComponentInstance) or e.is_a?(Sketchup::Group)}
	inss.each{|e|
		if e.visible? and e.layer.visible?
			mt1 = e.material || mt0
			t1  = t0 * e.transformation
			sel = e.definition.entities
			if not e.is_a?(Sketchup::Group)
				@geomlist[e.definition] = [] if not @geomlist[e.definition]
				@geomlist[e.definition].push [ mt1 , t1 ]
			end
			search_instances(sel, t1, mt1)
		end
	}
  end
def fcompress(v)
	return ( v * 10 ** @prec ).to_i.to_s(36)
end
def check_face(e, t, mat)
	has_texture = nil
	prec="%.3f"
	#mat = e.material if e.material != nil
	mat = e.material || mat
	if mat==nil
		matname = "default"
	else
		matname = mat.name
	end
	has_texture = ""
	has_texture = mat.texture if(mat != nil and mat.materialType == 1)
	mtn = self.store_mat(mat, matname, has_texture)

	norm = e.normal
	mesh = e.mesh 5
	cp=mesh.count_polygons
	(1..cp).each do |j|
		if @vts[@vtscnt].length > 6000
			@vtscnt += 1
			@vts[@vtscnt] = []
		end
		if @fcs[@fcscnt].length > 6000
			@fcscnt += 1
			@fcs[@fcscnt] = []
		end
		if @uvs[@uvscnt].length > 6000
			@uvscnt += 1
			@uvs[@uvscnt] = []
		end

		pts = mesh.polygon_points_at(j)
		uvi="["
		fc ="\""
		pts.each do |pt|
			k=mesh.point_index(pt)
			pn = pt.transform t
			pnx = "\"#{fcompress(pn.x)},#{fcompress(pn.y)},#{fcompress(pn.z)}\""
			#さらに数値を圧縮する方法として有効小数点以下桁数を決める。今のところ３位としたい。
			#10**3を掛けてから.to_s(36)で３６進数にして、html側で10進数にもどし10**3で割る
			
			vi = @vtsindices[pnx]
			if not vi
				vi = @vtsindices[pnx] = @vtsindices.size
				@vts[@vtscnt].push pnx
			end
			
			#-- SketchupのUV値をそのまま出力してる．．が
			#   これだとwebgl(three.js)のUVマッピングが変__150425現在
			if has_texture != ""
				pu = mesh.uv_at(k,1)
				pux=pu.x*1.0; puy=pu.y*1.0
				uvi += "[#{sprintf(prec,pux)}, #{sprintf(prec,puy)}],"
			else
				uvi += ","
			end
			fc+= "#{(vi + @vi).to_s(36)},"
		end
		uvi.chop!; uvi+="]"
		fc.chop!; fc+="\""
		@fcs[@fcscnt].push fc
		@uvs[@uvscnt].push uvi
		@mti << mtn
		@fi += 1
		#show_status "#{@fi}", SB_PROMPT
	end
	if @eds[@edscnt].length > 6000
		@edscnt += 1
		@eds[@edscnt] = []
	end
	e.edges.each{|ed|
	if ed.visible? and ed.layer.visible? and not ed.soft? and not ed.smooth? and not @edslist[ed]
		@edslist[ed] = true
		pt1 = ed.start.position.transform t
		pt2 = ed.end.position.transform t
		pt1i = @vtsindices["\"#{fcompress(pt1.x)},#{fcompress(pt1.y)},#{fcompress(pt1.z)}\""]
		pt2i = @vtsindices["\"#{fcompress(pt2.x)},#{fcompress(pt2.y)},#{fcompress(pt2.z)}\""]
		if pt1i and pt2i
			@eds[@edscnt].push "\"#{(pt1i + @vi).to_s(36)},#{(pt2i + @vi).to_s(36)}\""
			@ei += 1
		end
	end
	}

end

#----------------------------
	def export_textures(svname)
		dp=svname[0..svname.rindex(/\\/)]+"gl_image"
		dp=File.join(File.dirname(svname),"gl_image")
		Dir.mkdir(dp) if File.directory?(dp)==false
		model=Sketchup.active_model
		model.start_operation "texture export",true
		txgrp = model.entities.add_group
		txfc = {}
		@texnames_bymat = Hash.new("")#ここのマテリアルに対応したテクスチャファイル名を収納
		i = 0
		model.materials.each{|mat|
			if mat.texture
				txfc[mat] = txgrp.entities.add_face( [[0, 0, i],[0, 1, i],[1, 1, i],[1, 0, i]] )
				txfc[mat].material = mat
				i += 1
			end
		}
		tw = Sketchup.create_texture_writer
		hmlist = {}
		txfc.each{|mat,fc|
			h =  tw.load(fc,true)
			if h > 0
				hmlist[mat] = h
			end
		}
		
		tw.write_all(dp, true)
		hmlist.each{|mat,h|
			@texnames_bymat[mat] = tw.filename(h).downcase
		}
		tw = nil
		model.abort_operation
		show_status "exporting texture_end", SB_PROMPT
	end

  def store_mat(mat, mnam, mtex)
	m_ex = @mthash[mat]
	if m_ex
		return m_ex
	end
	m_ex=@mtl.size
	@mthash[mat] = m_ex
	if mtex==""
		col =mat.color
		mcol= "0x"+(sprintf("%2x",col.red)).sub(/ /,"0")+(sprintf("%2x",col.green)).sub(/ /,"0")+(sprintf("%2x",col.blue)).sub(/ /,"0")
		difs=[m_ex, mcol, mat.alpha, ""]
	else
		namtex = @texnames_bymat[mat] 
		col=mat.texture.average_color
		mcol= "0x"+(sprintf("%2x",col.red)).sub(/ /,"0")+(sprintf("%2x",col.green)).sub(/ /,"0")+(sprintf("%2x",col.blue)).sub(/ /,"0")
		difs=[m_ex, mcol, mat.alpha, namtex]
		@txs << [mnam, m_ex, namtex] 
	end
	difs[3] = "" if (@enbltx==0)
	@mtl << [mnam, difs].flatten
    return m_ex
  end


  def prompt()
    fn = UI.savepanel("Export>>WebGL(html)", nil, "*.html")
	return ["",0] unless fn
	fn = File.join(File.dirname(fn),File.basename(fn,".html") + ".html")
	return [fn,1]
=begin
    title   = "ExportModelToWebGL"
    enums   = [ "1|0" ]
    prompts = [ "Texture?(On:1/Off:0)" ]
    fn = "" if not fn
	fn = File.join(File.dirname(fn),File.basename(fn,".html") + ".html")
    f = fn.split(/\\/)[-1]
    values  = [ 0 ]
    results = inputbox( prompts, values, enums, title )
    return ["",0] if not results
    return [fn,results[0]]
=end
  end
def mirror_matrix4x4(tr)
	matrix = tr.to_a
	newmatrix = []
	h = 0
	4.times{|i|
	4.times{|j|
		newmatrix[ i * 4 + j ] = matrix[ j * 4 + i ]
	}
	}
	return Geom::Transformation.new(newmatrix)
end
def get_html_header()
code_header =%Q(
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0.1//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
<meta http-equiv="Content-Type" Content="text/html;charset=UTF-8">
<TITLE>SU2WebGL</TITLE>
<!--
<meta name="viewport" content="target-densitydpi=device-dpi, width=device-width, user-scalable=no" />
-->
)
end
def get_html_templete()
code=%Q(
<script id="main_wgl" type="text/javascript" >
  var materials = [];
  var clipMAX = 100.0;
  var clipMIN = 0.0;
  var camera,headlight;
  // 
  function init() {
    // init three
    if (window.WebGLRenderingContext) {
        renderer = new THREE.WebGLRenderer({ antialias: true });
    } else {
        renderer = new THREE.CanvasRenderer();
    }
	var chk_tex_ok = false;

    // viewport of WebGL
	aspr = window.innerWidth/ window.innerHeight;
    renderer.setPixelRatio( window.devicePixelRatio );
	renderer.setSize( window.innerWidth, window.innerHeight );
    document.getElementById('container').appendChild(renderer.domElement);

    // background color
    renderer.setClearColor(0x606069, 1.0);

    // init scene
    scene = new THREE.Scene();

    // init camera ( fov, aspect, near, far )
    camera = new THREE.PerspectiveCamera(50, aspr, 10, SCENE_MAX_LENGTH);
    scene.add(camera);

    // init 環境光　
    light1 = new THREE.AmbientLight(0xababab);
    scene.add( light1 );
    // init 平行光線：右上手前45degから強度1.0
    light1 = new THREE.DirectionalLight(0x666666, 1.0);
    light1.position.set(10000, 10000, 10000);
    scene.add( light1 );
    light2 = new THREE.DirectionalLight(0x333333, 1.0);
    light2.position.set(-10000, 10000, 0);
    scene.add( light2 );

    headlight = new THREE.DirectionalLight(0x333333, 1.0);
    headlight.position.set(0, 0, 0);
    scene.add( headlight );


    // init controls : use OrbitControls.js
    controls = new THREE.OrbitControlsTH(camera, renderer.domElement);
      controls.userZoom = true;        //true:ズーム操作可能,false:ズーム操作不可
      controls.userZoomSpeed = 1.0;    // ズーム速度
      controls.userRotate = true;      //true:回転操作可能,false:回転操作不可
      controls.userRotateSpeed = 1.0;  //回転速度
      controls.userPan = true;         //true:パン操作可能,false:パン操作不可
      controls.userPanSpeed = 1.0;     //パン速度
      controls.autoRotate = false;     //true:自動回転する,false:自動回転しない
      controls.autoRotateSpeed = 1.0;  //自動回転する時の速度
      controls.minPolarAngle = 0; 
      controls.maxPolarAngle = Math.PI; 
      controls.minDistance = 0;        //近づける距離の最小値
      controls.maxDistance = Infinity; //遠ざかれる距離の最大
    controls.object.position.set( CAMEYE );  //cAMEYE
    controls.target = new THREE.Vector3( CAMTGT ); //cAMTGT  
	controls.lookaround = false;
	
    // axis ３軸表示 : use LineAxisHelper.js
    axis = new THREE.AxisHelper(5000); 
    axis.position.set(0, 0, 0);
    scene.add(axis);
    // init materials
	codeclips = "vec3 clipDIST = vec3( SCENESIZE ) + vec3(40,40,40);vec3 clipBASE = vec3( SCENEMIN ) - vec3(20,20,20);"
    for(var i=0; i < mat.length; i++){
      materials[i] = new THREE.ShaderMaterial( {
		vertexShader: [	"#define LAMBERT","varying vec3 mdpos;","varying vec3 vLightFront;","#ifdef DOUBLE_SIDED","	varying vec3 vLightBack;","#endif",
			THREE.ShaderChunk[ "common" ],
			THREE.ShaderChunk[ "uv_pars_vertex" ],
			THREE.ShaderChunk[ "uv2_pars_vertex" ],
			THREE.ShaderChunk[ "envmap_pars_vertex" ],
			THREE.ShaderChunk[ "lights_lambert_pars_vertex" ],
			THREE.ShaderChunk[ "color_pars_vertex" ],
			THREE.ShaderChunk[ "morphtarget_pars_vertex" ],
			THREE.ShaderChunk[ "skinning_pars_vertex" ],
			THREE.ShaderChunk[ "shadowmap_pars_vertex" ],
			THREE.ShaderChunk[ "logdepthbuf_pars_vertex" ],
			"void main() {",
				THREE.ShaderChunk[ "uv_vertex" ],
				THREE.ShaderChunk[ "uv2_vertex" ],
				THREE.ShaderChunk[ "color_vertex" ],
				THREE.ShaderChunk[ "beginnormal_vertex" ],
				THREE.ShaderChunk[ "morphnormal_vertex" ],
				THREE.ShaderChunk[ "skinbase_vertex" ],
				THREE.ShaderChunk[ "skinnormal_vertex" ],
				THREE.ShaderChunk[ "defaultnormal_vertex" ],
				THREE.ShaderChunk[ "begin_vertex" ],
				THREE.ShaderChunk[ "morphtarget_vertex" ],
				THREE.ShaderChunk[ "skinning_vertex" ],
				THREE.ShaderChunk[ "project_vertex" ],
				THREE.ShaderChunk[ "logdepthbuf_vertex" ],
				THREE.ShaderChunk[ "worldpos_vertex" ],
				THREE.ShaderChunk[ "envmap_vertex" ],
				THREE.ShaderChunk[ "lights_lambert_vertex" ],
				THREE.ShaderChunk[ "shadowmap_vertex" ],
			"mdpos = vec3(position);}"
		].join( "\\n" ),
		fragmentShader: [
			"uniform float clipmaxX;", "uniform float clipminX;", "uniform float clipmaxY;", "uniform float clipminY;", "uniform float clipmaxZ;", "uniform float clipminZ;","uniform int use_clipping;",
			"varying vec3 mdpos;",
			"uniform vec3 diffuse;","uniform vec3 emissive;","uniform float opacity;","uniform vec3 ambientLightColor;","varying vec3 vLightFront;","#ifdef DOUBLE_SIDED","	varying vec3 vLightBack;","#endif",
			THREE.ShaderChunk[ "common" ],
			THREE.ShaderChunk[ "color_pars_fragment" ],
			THREE.ShaderChunk[ "uv_pars_fragment" ],
			THREE.ShaderChunk[ "uv2_pars_fragment" ],
			THREE.ShaderChunk[ "map_pars_fragment" ],
			THREE.ShaderChunk[ "alphamap_pars_fragment" ],
			THREE.ShaderChunk[ "envmap_pars_fragment" ],
			THREE.ShaderChunk[ "fog_pars_fragment" ],
			THREE.ShaderChunk[ "shadowmap_pars_fragment" ],
			THREE.ShaderChunk[ "specularmap_pars_fragment" ],
			THREE.ShaderChunk[ "logdepthbuf_pars_fragment" ],
			codeclips,
			"void main() {",
			"	vec3 outgoingLight = vec3( 0.0 );",
			"	vec4 diffuseColor = vec4( diffuse, opacity );",
			"	vec3 totalAmbientLight = ambientLightColor;",
			"	vec3 shadowMask = vec3( 1.0 );",
				THREE.ShaderChunk[ "logdepthbuf_fragment" ],
				THREE.ShaderChunk[ "map_fragment" ],
				THREE.ShaderChunk[ "color_fragment" ],
				THREE.ShaderChunk[ "alphamap_fragment" ],
				THREE.ShaderChunk[ "alphatest_fragment" ],
				THREE.ShaderChunk[ "specularmap_fragment" ],
				THREE.ShaderChunk[ "shadowmap_fragment" ],
				"	#ifdef DOUBLE_SIDED",
				"		if ( gl_FrontFacing )",
				"			outgoingLight += diffuseColor.rgb * ( vLightFront * shadowMask + totalAmbientLight ) + emissive;",
				"		else",
				"			outgoingLight += diffuseColor.rgb * ( vLightBack * shadowMask + totalAmbientLight ) + emissive;",
				"	#else",
				"		outgoingLight += diffuseColor.rgb * ( vLightFront * shadowMask + totalAmbientLight ) + emissive;",
				"	#endif",
				THREE.ShaderChunk[ "envmap_fragment" ],
				THREE.ShaderChunk[ "linear_to_gamma_fragment" ],
				THREE.ShaderChunk[ "fog_fragment" ],
				"if( use_clipping == 1 ){",
				"	vec3 clipmax = clipDIST * vec3( clipmaxX , clipmaxY , clipmaxZ ) * 0.01 + clipBASE;",
				"	vec3 clipmin = clipDIST * vec3( clipminX , clipminY , clipminZ ) * 0.01 + clipBASE;",
				"	vec3 linemax = clipDIST * vec3( clipmaxX , clipmaxY , clipmaxZ ) * 0.01 + clipBASE - vec3( 10,10,10 );",
				"	vec3 linemin = clipDIST * vec3( clipminX , clipminY , clipminZ ) * 0.01 + clipBASE + vec3( 10,10,10 );",
				"	if( any(lessThan( clipmax,mdpos )) || any(lessThan( mdpos,clipmin )) ){",
				"		discard;",
				"	}else if( any(lessThan( linemax,mdpos )) || any(lessThan( mdpos,linemin )) ){",
				"		gl_FragColor = vec4( outgoingLight, 1.0 ) * vec4(1.0,0.3,0.3,1.0);",
				"	}else{",
				"		gl_FragColor = vec4( outgoingLight, diffuseColor.a );",
				"	}",
				"}else{",
				"	gl_FragColor = vec4( outgoingLight, diffuseColor.a );",
				"}",
			"}"
		].join( "\\n" ),
		uniforms: THREE.UniformsUtils.merge([
			THREE.UniformsLib[ "common" ],
			THREE.UniformsLib[ "fog" ],
			THREE.UniformsLib[ "lights" ],
			THREE.UniformsLib[ "shadowmap" ],
			{
			clipmaxX: { type: 'f', value: clipMAX },
			clipminX: { type: 'f', value: clipMIN },
			clipmaxY: { type: 'f', value: clipMAX },
			clipminY: { type: 'f', value: clipMIN },
			clipmaxZ: { type: 'f', value: clipMAX },
			clipminZ: { type: 'f', value: clipMIN },
			opacity: { type: 'f', value: mat[i][1] },
			use_clipping: { type: 'i', value: 1 },
			diffuse: { type: 'c', value: new THREE.Color(mat[i][0]) },
			emissive : { type: "c", value: new THREE.Color( 0x000000 ) }
		}])
	  });
		if(mat[i][1] < 1.0){
			materials[i].transparent = true;
			materials[i].blending = THREE.NormalBlending;
		}
        materials[i].side = THREE.DoubleSide;
		materials[i].lights = true;
    }
	linemat = new THREE.ShaderMaterial( {
		vertexShader: "varying vec3 mdpos;void main() {mdpos = vec3(position);gl_Position = projectionMatrix * modelViewMatrix * vec4(position, 1.0);}",
		fragmentShader: [
			"uniform float clipmaxX;", "uniform float clipminX;", "uniform float clipmaxY;", "uniform float clipminY;", "uniform float clipmaxZ;", "uniform float clipminZ;","uniform int use_clipping;",
			"uniform vec3 diffuse;",
			"varying vec3 mdpos;",
			codeclips,
			"void main() {",
				"if( use_clipping == 1 ){",
				"	vec3 clipmax = clipDIST * vec3( clipmaxX , clipmaxY , clipmaxZ ) * 0.01 + clipBASE;",
				"	vec3 clipmin = clipDIST * vec3( clipminX , clipminY , clipminZ ) * 0.01 + clipBASE;",
				"	vec3 linemax = clipDIST * vec3( clipmaxX , clipmaxY , clipmaxZ ) * 0.01 + clipBASE - vec3( 10,10,10 );",
				"	vec3 linemin = clipDIST * vec3( clipminX , clipminY , clipminZ ) * 0.01 + clipBASE + vec3( 10,10,10 );",
				"	if( any(lessThan( clipmax,mdpos )) || any(lessThan( mdpos,clipmin )) ){",
				"		discard;",
				"	}else if( any(lessThan( linemax,mdpos )) || any(lessThan( mdpos,linemin )) ){",
				"		gl_FragColor = vec4( diffuse, 1.0 ) * vec4(1.0,0.3,0.3,1.0);",
				"	}else{",
				"		gl_FragColor = vec4( diffuse, 1.0 );",
				"	}",
				"}else{",
				"	gl_FragColor = vec4( diffuse, 1.0 );",
				"}",
			"}"
		].join( "\\n" ),
		uniforms: {
			clipmaxX: { type: 'f', value: clipMAX },
			clipminX: { type: 'f', value: clipMIN },
			clipmaxY: { type: 'f', value: clipMAX },
			clipminY: { type: 'f', value: clipMIN },
			clipmaxZ: { type: 'f', value: clipMAX },
			clipminZ: { type: 'f', value: clipMIN },
			opacity: { type: 'f', value: 1.0 },
			use_clipping: { type: 'i', value: 1 },
			diffuse: { type: 'c', value: new THREE.Color( 0x000000 ) },
			emissive : { type: "c", value: new THREE.Color( 0x000000 ) }
		},
			linewidth:2
		} );
		materials.push( linemat);
	//texture_show(true);
    // init objects
    //objects = new THREE.Group();
var mrot = new THREE.Matrix4()
mrot.makeRotationX(-Math.PI/2);
for(var k = 0;k < ngeom	; k++){
for(var l = 0;l < inslist[k].nins;l++){
var dfmatid = inslist[k].props[l].dfmat;
var matrix = new THREE.Matrix4();
var mtx = inslist[k].props[l].matrix;
matrix.set(
mtx[0]/mtx[15],mtx[4]/mtx[15],mtx[8]/mtx[15],mtx[12]/mtx[15],
mtx[1]/mtx[15],mtx[5]/mtx[15],mtx[9]/mtx[15],mtx[13]/mtx[15],
mtx[2]/mtx[15],mtx[6]/mtx[15],mtx[10]/mtx[15],mtx[14]/mtx[15],
mtx[3]/mtx[15],mtx[7]/mtx[15],mtx[11]/mtx[15],1.0
);
    var geom, vt,vt2, fc, mface,fst,vst;
    geom = new THREE.Geometry();
    for(var j=0; j < geomlist[k].nv; j++){
	  vst = geomlist[k].v[j].split(",");//
      vt = new THREE.Vector3(parseInt(vst[0],36)/Math.pow(10,prec),parseInt(vst[1],36)/Math.pow(10,prec),parseInt(vst[2],36)/Math.pow(10,prec));
      geom.vertices.push(vt);
    }
	
    for(var j=0; j < geomlist[k].nf; j++){
	  fst = geomlist[k].f[j].split(",")
      //fc = new THREE.Face3( f[j][0], f[j][1], f[j][2], null, null, mati[j] );
	  var mati = geomlist[k].mti[j];
	  if( mati == 0 ){ mati = dfmatid; }
	  fc = new THREE.Face3( parseInt(fst[0], 36), parseInt(fst[1], 36), parseInt(fst[2], 36), null, null, mati );
      //fc.normal = new THREE.Vector3(v[f[j][0]][3], v[f[j][0]][4], v[f[j][0]][5]);
      geom.faces.push(fc);
      // has_texture
	  i = mati;
      if( mat[i][2] != ""){
        geom.faceVertexUvs[0].push( [
          new THREE.Vector2(geomlist[k].uv[j][0][0],geomlist[k].uv[j][0][1]),
          new THREE.Vector2(geomlist[k].uv[j][1][0],geomlist[k].uv[j][1][1]),
          new THREE.Vector2(geomlist[k].uv[j][2][0],geomlist[k].uv[j][2][1])]  );
      }else{
        geom.faceVertexUvs[0].push( [[0,0],[0,0],[0,0]] );
      }
    }
	
    geom.computeFaceNormals();
	geom.applyMatrix(matrix);
	geom.applyMatrix(mrot);
	//geom.translate(mtx[12],-mtx[13],-mtx[14]);
	
    //geom.computeVertexNormals();
    mface = new THREE.Mesh(geom, new THREE.MeshFaceMaterial(materials));
    scene.add( mface );
	var edgeom = new THREE.Geometry();
    for(var j=0; j < geomlist[k].ne; j++){
		if(geomlist[k].ed[j]){
		edst = geomlist[k].ed[j].split(",")
		vst = geomlist[k].v[parseInt(edst[0], 36)].split(",");//
		edgeom.vertices.push( new THREE.Vector3(parseInt(vst[0],36)/Math.pow(10,prec),parseInt(vst[1],36)/Math.pow(10,prec),parseInt(vst[2],36)/Math.pow(10,prec)) );
		vst = geomlist[k].v[parseInt(edst[1], 36)].split(",");//
		edgeom.vertices.push( new THREE.Vector3(parseInt(vst[0],36)/Math.pow(10,prec),parseInt(vst[1],36)/Math.pow(10,prec),parseInt(vst[2],36)/Math.pow(10,prec)) );
		}
    }
	edgeom.applyMatrix(matrix);
	edgeom.applyMatrix(mrot);
	//edgeom.translate(mtx[12],-mtx[13],-mtx[14]);
	var lines = new THREE.LineSegments( edgeom,linemat );
	scene.add( lines );
}
}
	var gui = new dat.GUI();
	parameters = {
		scene: "",
		lookaround:false,
		textureon:false,
		useclip:true,
		gclipxmax:1.0,
		gclipxmin:1.0,
		gclipymax:1.0,
		gclipymin:1.0,
		gclipzmax:1.0,
		gclipzmin:1.0
	};
	var skpage = gui.add( parameters, 'scene', [ SCENE_LIST ] ).name('scene').listen();
	skpage.onChange(function(value){
		switch( value ){
			SCENE_SELECT
		}
		controls.object.position.set(cpos[0],cpos[1],cpos[2]);
		controls.target = new THREE.Vector3(ctgt[0],ctgt[1],ctgt[2] ); 
		document.activeElement.blur();
	});
	var sklookaround = gui.add( parameters, 'lookaround' ).name('LOOK AROUND').listen();
	sklookaround.onChange(function(value){   controls.lookaround = value;  	});
	var sktextureon = gui.add( parameters, 'textureon' ).name('Texture ON/OFF').listen();
	sktextureon.onChange(function(value){   texture_show( value);  	});
	
	var f_clips = gui.addFolder('CLIP PLANE');
	var skuseclip = f_clips.add( parameters, 'useclip' ).name('USE CLIPPING').listen();
	skuseclip.onChange(function(value){
		for(var i=0; i < materials.length; i++){
			materials[i].uniforms.use_clipping.value = value;
		}
	});
	var skclipxmax = f_clips.add( parameters, 'gclipxmax' , clipMIN , clipMAX).name('CLIP X MAX').listen();
	skclipxmax.onChange(function(value){
		for(var i=0; i < materials.length; i++){
			materials[i].uniforms.clipmaxX.value = value;
		}
	});
	var skclipxmin = f_clips.add( parameters, 'gclipxmin' , clipMIN , clipMAX).name('CLIP X MIN').listen();
	skclipxmin.onChange(function(value){
		for(var i=0; i < materials.length; i++){
			materials[i].uniforms.clipminX.value = value;
		}
	});
	
	var skclipzmax = f_clips.add( parameters, 'gclipzmax' , clipMIN , clipMAX).name('CLIP Y MAX').listen();
	skclipzmax.onChange(function(value){
		for(var i=0; i < materials.length; i++){
			materials[i].uniforms.clipmaxZ.value = value;
		}
	});
	var skclipzmin = f_clips.add( parameters, 'gclipzmin' , clipMIN , clipMAX).name('CLIP Y MIN').listen();
	skclipzmin.onChange(function(value){
		for(var i=0; i < materials.length; i++){
			materials[i].uniforms.clipminZ.value = value;
		}
	});

	var skclipymax = f_clips.add( parameters, 'gclipymax' , clipMIN , clipMAX).name('CLIP Z MAX').listen();
	skclipymax.onChange(function(value){
		for(var i=0; i < materials.length; i++){
			materials[i].uniforms.clipmaxY.value = value;
		}
	});
	var skclipymin = f_clips.add( parameters, 'gclipymin' , clipMIN , clipMAX).name('CLIP Z MIN').listen();
	skclipymin.onChange(function(value){
		for(var i=0; i < materials.length; i++){
			materials[i].uniforms.clipminY.value = value;
		}
	});

	gui.open();
	f_clips.open;
	parameters.gclipxmax = clipMAX;
	parameters.gclipymax = clipMAX;
	parameters.gclipzmax = clipMAX;
	parameters.gclipxmin = clipMIN;
	parameters.gclipymin = clipMIN;
	parameters.gclipzmin = clipMIN;

    //scene.add( objects );
    // 画面リサイズ時のイベント
    window.addEventListener( 'resize', onWindowResize, false );
  }

  // ウィンドウリサイズ時の動作
  function onWindowResize() {
	renderer.setSize( window.innerWidth, window.innerHeight );
	camera.aspect = window.innerWidth/ window.innerHeight;
	camera.updateProjectionMatrix();
    //render();
  }
function texture_show(chk){
    for(var i=0; i < mat.length; i++){
      if (mat[i][2] != ""){
        // texture付material：画像をLoad
		if(chk){
			var texture  = new THREE.ImageUtils.loadTexture(tex[i]);
			texture.magFilter = THREE.NearestFilter;
			texture.minFilter = THREE.NearestFilter;
			texture.wrapS = THREE.RepeatWrapping;
			texture.wrapT = THREE.RepeatWrapping;
			materials[i].map = texture;
			//materials[i].overdraw = true;
			materials[i].needsUpdate = true;
		}else{
			materials[i].map = null;
			//materials[i].overdraw = true;
			materials[i].needsUpdate = true;
		}
      }
    }
}
  // 
  function render() {
    requestAnimationFrame(render);
    controls.update();
    renderer.render(scene, camera);
  }

</script>
</head>
<body onload="main_wgl();" style="overflow: hidden;height: 100%;">
  <div id="container"></div>
  <div id="menu"> </div>
</body></html>
)#%Q記法 END
end
end
# add a menu 
if (not file_loaded?("t2h_export_webgl.rb"))
  tew_menu = UI.menu("Plugins").add_submenu("Export>>WebGL")
  tew_menu.add_item("Export(as splited files)") {Webgl_export.new(false,false)}
  tew_menu.add_item("Export(as one files)") {Webgl_export.new(true,false)}
end
file_loaded("t2h_export_webgl.rb")
#----------------------------
end
end
